FOR /D /r %%F in ("*") DO (
    pushd %CD%
    cd %%F
    FOR %%X in (*.bz2) DO (
        "C:\Program Files\7-zip\7z.exe" x %%X
    )
    FOR %%X in (*.tar) DO (
        "C:\Program Files\7-zip\7z.exe" x -aoa %%X
    )
    DEL *.bz2
    DEL *.tar
    popd
)